## Distncia entre cidades
## 1. Construa uma matriz de distncias com esses valores.
r = c("Atenas","Madrid","Paris","Estocolmo")
cidades = list(r,r)
c1 = c(0, 3949, 3000, 3927)
c2 = c(3949, 0, 1273, 3188)
c3 = c(3000, 1273, 0, 1827)
c4 = c(3927, 3188, 1827, 0)

dist = matrix(c(c1,c2,c3,c4), nrow=4,ncol=4, dimnames= cidades)

## 2. Compare a sua matriz com o objeto eurodist, disponvel no pacote datasets.
library(datasets)
eurodist2 = as.matrix(eurodist)
eurodist2 = eurodis2(c("Athens","Madrid","Paris","Stockholm"),c("Athens","Madrid","Paris","Stockholm"))
dist == eurodist2

##Criao de um data frame
## 1. Crie um data frame com esses dados, na qual cada hamster seja linha, e as colunas sejam as variveis cor, dieta, e variao do peso.
pesos = c(0.1,1.1,3.7,5.7,-1.2,-1.5,3.0,-0.4,0.6,1.5,-0.1,2.0,0.6,-3.0,-0.3,-0.2,0.3,1.5)
dietas = c( rep  (rep(c("Dieta_A", "Dieta_B","Dieta_C"), each=3), each=2)) ##3 hamsters de cada dieta para cada uma das 2 cores
cores = factor( rep(    c("Claro","Escuro"), each = 9))  ## 9 hamsters de cada cor
hamster = data.frame(cor= cores, dieta = dietas, peso = pesos)

## 2. Qual  a mdia por dieta e por fentipo?
tapply(hamster$peso,INDEX=hamster$cor,FUN=mean)
tapply(hamster$peso,INDEX=hamster$dieta,FUN=mean)


## Criando uma Matriz
## 1. Crie um objeto da classe matriz com 5 colunas e 3 linhas contendo uma amostra de uma distribuio normal de mdia 10 e varincia 3,6. 
matriz = matrix(data = c(rnorm(15,10,3.6)),nrow=3,ncol=5)

## 2. Mude os nomes das linhas para "L1" a "L3" e das colunas para "C1" a "C5". Dica: A funo paste combinada com funes de repeties podem lhe poupar trabalho.
rows = c("L1","L2","L3")
cols = c("C1","C2","C3","C4","C5")
attributes(matriz)$dimnames = list(rows,cols)

## 3. Calcule a mdia e a varincia por colunas e depois por linhas. Guarde os resultados em um dataframe , cujas colunas so a mdia e a varincia de cada subconjunto dos dados.
medias = c(mean(matriz[,1]),mean(matriz[,2]),mean(matriz[,3]),mean(matriz[,4]),mean(matriz[,5]),mean(matriz[1,]),mean(matriz[2,]),mean(matriz[3,]))
variancias = c(var(matriz[,1]),var(matriz[,2]),var(matriz[,3]),var(matriz[,4]),var(matriz[,5]),var(matriz[1,]),var(matriz[2,]),var(matriz[3,]))
data = data.frame(dados=subconjuntos,media=medias,variancia=variancias)


##Lendo e salvando os seus dados
#Leia um arquivo de dados de sua autoria e faa um sumrio das variveis independentes. Caso tenha variveis qualitativas faa tabelas de contagem para cada uma e duas a duas. 
##Caso no tenha dados, poder ir a campo ou utilize alguns dos dados da rea Arquivos de dados do nosso wiki.

##vou usar os dados do arquivo esaligna.csv da wiki
esaligna = read.table("esaligna.csv",header=TRUE,sep=",")
summary(esaligna)

## 2. Faa uma seleo de um estado de atributo de um vetor fator dos seus dados e salve em um objeto (uma espcie, uma localidade...), mantendo o objeto original intacto.
##Em seguida selecione apenas trs colunas no objeto resultante e salve em um arquivo de formato .txt, separado por tabulao e sem nome de linhas. 
esaligna2 = esaligna[esaligna$classe=="a",]
esaligna3 = esaligna2[,c(1,2,3)]
write(t(as.matrix(esaligna3)), file="esaligna3.txt",sep="\t",ncolumns=3)

##Classes de objetos
## 1. Quais so as classes desses dois objetos? 

##ps: j importamos datasets no comeo dos exerccios
class(iris)
## [1] "data.frame"
class(iris3)
## [1] "array"

## 2. Calcule a mdia de cada uma das quatro medidas por espcie, dos dois objetos. DICAS: as funes da famlia apply e a funo by iro te ajudar.
tapply(iris$Sepal.Length, INDEX=iris$Species, FUN=mean)
tapply(iris$Sepal.Width, INDEX=iris$Species, FUN=mean)
tapply(iris$Petal.Length, INDEX=iris$Species, FUN=mean)
tapply(iris$Petal.Width, INDEX=iris$Species, FUN=mean)

##Sepal.Length
mean(iris3[,1,1])
mean(iris3[,1,2])
mean(iris3[,1,3])
#Sepal.Width
mean(iris3[,2,1])
mean(iris3[,2,2])
mean(iris3[,2,3])
#Petal.Length
mean(iris3[,2,1])
mean(iris3[,2,2])
mean(iris3[,2,3])
#Petal.Width
mean(iris3[,3,1])
mean(iris3[,3,2])
mean(iris3[,3,3])

## 3. Os nomes das variaveis esto em ingls. Mude-os para portugus no objeto iris. DICA: Como tudo mais no R, os resultados da funo names podem ser armazenados em um objeto.
names(iris) = c("Comprimento.Sepala", "Largura.Sepala", "Comprimento.Petala", "Largura.Petala", "Especies")


## Acrescentando Dados de Sntese

##   1. Crie um objeto com os dados do arquivo-texto Biomassa de rvores de Eucalyptus saligna.
esaligna = read.table("esaligna.csv",header=TRUE,sep=",")

##   2. Verifique o contedo do objeto resultante, com a funo summary.
summary(esaligna)

##   3. Acrescente uma nova coluna ao data frame resultante, com a soma das biomassas de folhas e do tronco de cada rvore.
esaligna$soma = esaligna$tronco + esaligna$folha

##   4. Acrescente outra coluna, com o valor da rea basal de cada rvore.
esaligna$area = ((esaligna$dap/2)^2)*pi

##   5. Calcule a rea basal total por talho e salve em um objeto
obj = esaligna$area/esaligna$talhao

##   6. Calcule a mdia da rea basal por talho
mean(obj)

##   7. Selecione apenas os dados relativos  rvores com mais de 10 cm de dimetro
obj2 = esaligna[esaligna$dap>10,]

##   8. Salve em um arquivo txt, separado por tabulao.
write(t(as.matrix(obj2)), file="esaligna_.txt",sep="\t",ncolumns=11)



